#####################################################################################
#
# This package is intended to create a basic qmail and vpopmail install.
#
# Vpopmail requires Qmail already installed but Qmail patching requires Vpopmail for
# authentication.  Possibly more.  This rpm will seek to fix build dependancies.
#
#####################################################################################

%define         pversion 1.0
%define         bversion 23
%define 	rpmrelease iworx
%define 	qmaildir /var/qmail
%define		servicedir /service
%define         release %{bversion}.noarch.%{rpmrelease}

#####################################################################################

# From Vpopmail
%define 	vdir /home/vpopmail
%define 	qdir /var/qmail
%define		iworxdir /home/interworx

#####################################################################################



%define		iworxmysqllibdir %{iworxdir}/mysql/usr/lib64/mysql

%define		ccflags %{optflags} -I%{iworxdir}/mysql/usr/include/mysql
%define		ldflags %{optflags} -L%{iworxmysqllibdir} -lpthread -lm -lrt -lssl -lcrypto -ldl

#####################################################################################

Summary:      InterWorx Base Users
Name:         interworx-prep-vpopmail
Version:      %{pversion}
Release:      %{release}
License:      Commercial
Group:	      Development/Languages
Distribution: InterWorx-HAL
Vendor:       INTERWORX L.L.C
Packager:     Joseph Purkis <jpurkis@interworx.com>

Buildroot:	%{_tmppath}/%{name}-%{version}-root

BuildRequires:     zlib-devel
#BuildRequires:     iworx-db-55
BuildRequires:     openssl-devel
BuildRequires:     interworx-unix-users
Requires:     zlib-devel
#Requires:     iworx-db-55
Requires:     openssl-devel
Requires:     interworx-unix-users

Source0:      netqmail-1.06.tar.gz

Patch0:    qmail-1.03-chkshsgr-bug.patch

%description
Helper package for building vpopmail.

%pre

if [ -f /usr/local/interworx/iworx.ini] ; then
   echo
   echo "ERROR: InterWorx present on system. Intended for Vpopmail builds only!"
   echo
   exit 1
fi

%global debug_package %{nil}

%prep
%setup -q -n netqmail-1.06
%patch0 -p1

#####################################################################################

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file

if [ -f %{_tmppath}/%{name}-%{pversion}-gcc ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-gcc ; fi

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"
export LDFLAGS="%{ldflags}"

%build
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
mkdir -p %{buildroot}
#cd netqmail-1.06
make clean
make


#cd /usr/local/src
#wget https://notes.sagredo.eu/files/qmail/tar/vpopmail-5.4.33.tar.gz
#tar xzf vpopmail-5.4.33.tar.gz
#cd vpopmail-5.4.33
#chown -R root.root .
#autoreconf -f -i
#./configure \
#        --enable-qmaildir=/var/qmail/ \
#        --enable-auth-module=mysql \
#        --enable-incdir=%{iworxdir}/mysql/usr/include/mysql \
#        --enable-libdir=%{iworxmysqllibdir}
#make install-strip

%install

export PATH="/sbin:/usr/sbin:/bin:/usr/bin"

##
# Make /etc/tcprules.d/qmail-smtp
##

mkdir -p %{buildroot}%{_sysconfdir}/tcprules.d

##
# Setup default /etc/tcprules.d/qmail-smtp
##
cat <<EOFqmail-smtp >%{buildroot}%{_sysconfdir}/tcprules.d/tcp.smtp
127.:allow,RELAYCLIENT="",JGREYLIST=""
::1:allow,RELAYCLIENT="",JGREYLIST=""
:allow,LANG="en_US",QMAILQUEUE="/var/qmail/bin/simscan",CHKUSER_MBXQUOTA="99",JGREYLIST_DIR="/var/qmail/jgreylist",JGREYLIST=""
EOFqmail-smtp

##
# create the install dirs
##

install -d %{buildroot}%{_sysconfdir}/cron.hourly
install -d %{buildroot}%{qmaildir}/alias
install -d %{buildroot}%{qmaildir}
install -d %{buildroot}%{qmaildir}/control
install -d %{buildroot}%{qmaildir}/owners
install -d %{buildroot}%{qmaildir}/users
install -d %{buildroot}%{qmaildir}/spam
install -d %{buildroot}%{_sysconfdir}/tcpcontrol
install -d %{buildroot}%{qmaildir}/bin
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{qmaildir}/man
install -d %{buildroot}%{_sbindir}

##
# install files needed
##

install -d -m0755  %{buildroot}%{qmaildir}
for i in bin boot control doc man users; do
  install -d -m0755 %{buildroot}%{qmaildir}/$i
done

for i in man1 man5 man7 man8; do
  install -d -m0755  %{buildroot}%{qmaildir}/man/$i
done

for i in cat1 cat5 cat7 cat8; do
  install -d -m0755 %{buildroot}%{qmaildir}/man/$i
done

install -d -m0700 %{buildroot}%{servicedir}
for i in send smtp pop3 ; do
  install -d -m01751 %{buildroot}%{servicedir}/$i
  install -d -m0751 %{buildroot}%{servicedir}/$i/log
  install -d -m0751 %{buildroot}%{servicedir}/$i/supervise
done

install -d -m0750 %{buildroot}%{qmaildir}/queue
install -d -m02755 %{buildroot}%{qmaildir}/alias

install -d -m0755 %{buildroot}/var/log/
install -d -m0755 %{buildroot}/var/log/send
install -d -m0755 %{buildroot}/var/log/smtp
install -d -m0755 %{buildroot}/var/log/pop3

##
# install binaries
##

for i in bouncesaying condredirect datemail elq except forward instcheck maildir2mbox maildirmake maildirwatch mailsubj pinq predate preline qail qbiff; do
  install -m0755 $RPM_BUILD_DIR/netqmail-1.06/$i %{buildroot}%{qmaildir}/bin
done

for i in qmail-clean qmail-getpw qmail-local qmail-popup qmail-pw2u qmail-remote qmail-rspawn qmail-send splogger; do
  install -m0711 $RPM_BUILD_DIR/netqmail-1.06/$i %{buildroot}%{qmaildir}/bin
done

for i in qmail-lspawn qmail-newmrh qmail-newu qmail-start; do
  install -m0700 $RPM_BUILD_DIR/netqmail-1.06/$i %{buildroot}%{qmaildir}/bin
done

install -m04711 $RPM_BUILD_DIR/netqmail-1.06/qmail-queue %{buildroot}%{qmaildir}/bin

for i in qmail-inject qmail-pop3d qmail-qmqpc qmail-qmqpd qmail-qmtpd qmail-qread qmail-qstat qmail-showctl qmail-smtpd qmail-tcpok qmail-tcpto qreceipt qsmhook sendmail tcp-env; do
  install -m0755 $RPM_BUILD_DIR/netqmail-1.06/$i %{buildroot}%{qmaildir}/bin
done

##
# install boot
##

for i in home home+df binm1 binm2+df proc+df binm2 binm3 proc binm3+df binm1+df; do
  install -m0755 $RPM_BUILD_DIR/netqmail-1.06/$i %{buildroot}%{qmaildir}/boot
done

##
# build the queue
##

for i in bounce info intd local lock mess pid remote todo; do
  install -d %{buildroot}%{qmaildir}/queue/$i
done

for d in info local mess remote; do
  for i in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22; do
    install -d %{buildroot}%{qmaildir}/queue/$d/$i
  done
done

##
# the rest
##

touch %{buildroot}%{qmaildir}/queue/lock/sendmutex
touch %{buildroot}%{qmaildir}/queue/lock/tcpto

mkfifo -m 0622 %{buildroot}%{qmaildir}/queue/lock/trigger

install -m0755 instcheck %{buildroot}%{qmaildir}/bin
install -m0755 config-fast %{buildroot}%{qmaildir}/bin

##
# startup scripts
##

mkdir -p %{buildroot}/var/log/{smtp,pop3,send}
mkdir -p %{buildroot}/etc/domainkeys

mkdir -p %{buildroot}%{qmaildir}/plugins

%clean
#[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
#[ -d %{_builddir}/%{name}-%{pversion} ] && rm -rf %{_builddir}/%{name}-%{pversion}

%files
%defattr(-,-,qmail)

# config (system)
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/tcprules.d/tcp.smtp

# directories
%attr(0755,root,qmail) %dir %{qmaildir}
%attr(02755,alias,qmail) %dir %{qmaildir}/alias
%attr(0755,root,qmail) %dir %{qmaildir}/bin
%attr(0755,root,qmail) %dir %{qmaildir}/boot
%attr(0755,root,qmail) %dir %{qmaildir}/control
%attr(0755,root,qmail) %dir %{qmaildir}/plugins
%attr(0755,root,qmail) %dir %{qmaildir}/doc
%attr(0755,root,qmail) %dir %{qmaildir}/man
%attr(0755,root,qmail) %dir %{qmaildir}/man/cat1
%attr(0755,root,qmail) %dir %{qmaildir}/man/cat5
%attr(0755,root,qmail) %dir %{qmaildir}/man/cat7
%attr(0755,root,qmail) %dir %{qmaildir}/man/cat8
%attr(0755,root,qmail) %dir %{qmaildir}/man/man1
%attr(0755,root,qmail) %dir %{qmaildir}/man/man5
%attr(0755,root,qmail) %dir %{qmaildir}/man/man7
%attr(0755,root,qmail) %dir %{qmaildir}/man/man8
%attr(0750,qmailq,qmail) %dir %{qmaildir}/queue
%attr(01700,qmaill,qmail) %dir %{servicedir}/send
%attr(0700,qmaill,qmail) %dir %{servicedir}/send/log
%attr(0700,qmaill,qmail) %dir %{servicedir}/send/supervise
%attr(01700,qmaill,qmail) %dir %{servicedir}/smtp
%attr(0700,qmaill,qmail) %dir %{servicedir}/smtp/log
%attr(0700,qmaill,qmail) %dir %{servicedir}/smtp/supervise
%attr(0755,root,qmail) %dir %{qmaildir}/users
%attr(0755,root,qmail) %dir %{qmaildir}/spam
%attr(0750,qmaill,qmail) %dir /var/log/smtp
%attr(0750,qmaill,qmail) %dir /var/log/send
%attr(0755,qmailr,root) %dir /etc/domainkeys

# qmail queue
%attr(0700,qmails,qmail) %dir %{qmaildir}/queue/bounce
%attr(0700,qmails,qmail) %dir %{qmaildir}/queue/info
%attr(0700,qmails,qmail) %{qmaildir}/queue/info/*
%attr(0700,qmailq,qmail) %dir %{qmaildir}/queue/intd
%attr(0700,qmails,qmail) %dir %{qmaildir}/queue/local
%attr(0700,qmails,qmail) %{qmaildir}/queue/local/*
%attr(0750,qmailq,qmail) %dir %{qmaildir}/queue/lock
%attr(0600,qmails,qmail) %{qmaildir}/queue/lock/sendmutex
%attr(0644,qmailr,qmail) %{qmaildir}/queue/lock/tcpto
%attr(-,qmails,qmail) %{qmaildir}/queue/lock/trigger
%attr(0750,qmailq,qmail) %dir %{qmaildir}/queue/mess
%attr(0750,qmailq,qmail) %{qmaildir}/queue/mess/*
%attr(0700,qmailq,qmail) %dir %{qmaildir}/queue/pid
%attr(0700,qmails,qmail) %dir %{qmaildir}/queue/remote
%attr(0700,qmails,qmail) %{qmaildir}/queue/remote/*
%attr(0750,qmailq,qmail) %dir %{qmaildir}/queue/todo

# boot files
%attr(0755,root,qmail) %{qmaildir}/boot/home
%attr(0755,root,qmail) %{qmaildir}/boot/home+df
%attr(0755,root,qmail) %{qmaildir}/boot/binm1
%attr(0755,root,qmail) %{qmaildir}/boot/binm2+df
%attr(0755,root,qmail) %{qmaildir}/boot/proc+df
%attr(0755,root,qmail) %{qmaildir}/boot/binm2
%attr(0755,root,qmail) %{qmaildir}/boot/binm3
%attr(0755,root,qmail) %{qmaildir}/boot/proc
%attr(0755,root,qmail) %{qmaildir}/boot/binm3+df
%attr(0755,root,qmail) %{qmaildir}/boot/binm1+df

# binaries
%attr(0755,root,qmail) %{qmaildir}/bin/bouncesaying
%attr(0755,root,qmail) %{qmaildir}/bin/condredirect
%attr(0755,root,qmail) %{qmaildir}/bin/config-fast
%attr(0755,root,qmail) %{qmaildir}/bin/datemail
%attr(0755,root,qmail) %{qmaildir}/bin/elq
%attr(0755,root,qmail) %{qmaildir}/bin/except
%attr(0755,root,qmail) %{qmaildir}/bin/forward
%attr(0755,root,qmail) %{qmaildir}/bin/instcheck
%attr(0755,root,qmail) %{qmaildir}/bin/maildir2mbox
%attr(0755,root,qmail) %{qmaildir}/bin/maildirmake
%attr(0755,root,qmail) %{qmaildir}/bin/maildirwatch
%attr(0755,root,qmail) %{qmaildir}/bin/mailsubj
%attr(0755,root,qmail) %{qmaildir}/bin/pinq
%attr(0755,root,qmail) %{qmaildir}/bin/predate
%attr(0755,root,qmail) %{qmaildir}/bin/preline
%attr(0755,root,qmail) %{qmaildir}/bin/qail
%attr(0755,root,qmail) %{qmaildir}/bin/qbiff
%attr(0711,root,qmail) %{qmaildir}/bin/qmail-clean
%attr(0711,root,qmail) %{qmaildir}/bin/qmail-getpw
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-inject
%attr(0711,root,qmail) %{qmaildir}/bin/qmail-local
%attr(0700,root,qmail) %{qmaildir}/bin/qmail-lspawn
%attr(0700,root,qmail) %{qmaildir}/bin/qmail-newmrh
%attr(0700,root,qmail) %{qmaildir}/bin/qmail-newu
%attr(0711,root,qmail) %{qmaildir}/bin/qmail-pw2u
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-qread
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-qstat
%attr(04711,qmailq,qmail) %{qmaildir}/bin/qmail-queue
%attr(0711,root,qmail) %{qmaildir}/bin/qmail-rspawn
%attr(0711,root,qmail) %{qmaildir}/bin/qmail-send
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-showctl
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-smtpd
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-qmqpc
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-qmqpd
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-qmtpd
%attr(0700,root,qmail) %{qmaildir}/bin/qmail-start
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-tcpok
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-tcpto
%attr(0755,root,qmail) %{qmaildir}/bin/qreceipt
%attr(0755,root,qmail) %{qmaildir}/bin/qsmhook
%attr(0755,root,qmail) %{qmaildir}/bin/sendmail
%attr(0711,root,qmail) %{qmaildir}/bin/splogger
%attr(0755,root,qmail) %{qmaildir}/bin/tcp-env
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-pop3d
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-popup
%attr(0755,root,qmail) %{qmaildir}/bin/qmail-remote


%changelog

* Thu Oct 14 2021 Joseph Purkis <jpurkis@interworx.com>
- Added basic build of qmail and a commented vpopmail install that I used for testing.
- This is for use as a dependancy for vpopmail as it looks for the qmaildir and then "$qmaildir"/bin/qmail-newu.
- Did not go beyond this test.
- Qmail on the other hand needs vpopmail before it can be fully patched and compiled.
- Take a look at https://notes.sagredo.eu/en/qmail-notes-185/netqmail-106-basic-setup-42.html,
- a large number of qmail patch's are post vpopmail install.
